/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_isqt.c,v 1.2 1997/09/25 18:18:48 ae59 Exp $ */
/*
$Log: t_isqt.c,v $
 * Revision 1.2  1997/09/25  18:18:48  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:37  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctInterval replaced         */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-09-06 : reduce maximum line length                 */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctInterval(t_isqt,isqrtee) */
#ifdef LINT_ARGS
a_intv t_isqt(a_intv ai)
#else
a_intv t_isqt(ai)

a_intv ai;
#endif
        {

        a_intv   res;
        int      rnd, rc;
        IExtReal  a, r;

        E_SPUSH("t_isqt")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&ai.INF, &a.l);
        longreal_to_extreal((LongReal *)&ai.SUP, &a.u);

        if ((rc = isqrtee(&a, &r))!=0)
            ieee_aborti1(rc, &ai);

        setrndmode(DOWN);
        if ((rc = extreal_to_longreal(&r.l, (LongReal *)&res.INF))!=0)
             ieee_aborti1(rc, &ai);
        setrndmode(UP);
        if ((rc = extreal_to_longreal(&r.u, (LongReal *)&res.SUP))!=0)
            ieee_aborti1(rc, &ai);
        setrndmode(rnd);

        E_SPOPP("t_isqt")
        return res;
        }

/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | isqrtee                                                      |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int isqrtee (const IExtReal *arg, IExtReal *res)
#else
int isqrtee (arg, res)
const IExtReal   *arg;
      IExtReal   *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int isqrtee (IExtReal *arg, IExtReal *res)
#else
int isqrtee (arg, res)
IExtReal   *arg;
IExtReal   *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   int         retu;       /* Rueckgabe                             */
   int         retl;       /* Rueckgabe                             */
   int         rnd;        /* RundungsMode                          */
   int         check;      /* Rueckgabe von Makro ArgCheck          */
   ExtReal     tmp1, tmp2; /* Test auf exaktes Ergebnis             */

   /* --- pruefe Argument, dann Pruefung aus --- */
   ArgCheckI1(ISqrt, arg, res);
   arg_check = Off;

   /* --- RundungsMode sichern, NEAR setzen --- */
   rnd  = getrndmode();
   setrndmode(NEAR);

   /* Punktargument ? */
   if (!cmpee(&(arg->u), &(arg->l)))
   {
      if (NoErr!=(retu = _s_sqrt(&(arg->u), &(res->u))))
      {
         arg_check = On;
         return(retu);
      }
      copyee(&(res->u), &(res->l));
      setrndmode(UP);
      mulee(&(res->u), &(res->u), &tmp1);
      setrndmode(DOWN);
      mulee(&(res->u), &(res->u), &tmp2);
      setrndmode(NEAR);
      /* ist das Ergebnis exakt ? */
      if (0!=cmpee(&tmp1, &tmp2) || 0!=cmpee(&tmp1, &(arg->u)))
      {
         /* nein, runden */
         if (cmpee(&tmp1, &(arg->u))<=0)
            round_rel(UP, &(res->u), &EpsSqrt, &(res->u));
         else if (cmpee(&tmp2, &(arg->u))>=0)
            round_rel(DOWN, &(res->l), &EpsSqrt, &(res->l));
         else
            iround_rel(res, &EpsSqrt, res);
      }
   }
   else   /* echtes Intervall als Argument */
   {

      /* --- Wurzel --- */
      retu  = _s_sqrt(&(arg->u), &(res->u));
      retl  = _s_sqrt(&(arg->l), &(res->l));

      /* --- Abbruch bei Fehler --- */
      if(NoErr!=retu||NoErr!=retl) {
         arg_check = On;
         return max(retu, retl);
      }

      /* sind linke oder rechte Grenze exakt ? */
      setrndmode(UP);
      mulee(&(res->l), &(res->l), &tmp1);
      setrndmode(DOWN);
      mulee(&(res->l), &(res->l), &tmp2);
      setrndmode(NEAR);
      /* ist das Ergebnis exakt ? */
      if (0!=cmpee(&tmp1, &tmp2) || 0!=cmpee(&tmp1, &(arg->l)))
      {
         /* nein, runden */
         round_rel(DOWN, &(res->l), &EpsSqrt, &(res->l));
      }
      setrndmode(UP);
      mulee(&(res->u), &(res->u), &tmp1);
      setrndmode(DOWN);
      mulee(&(res->u), &(res->u), &tmp2);
      setrndmode(NEAR);
      /* ist das Ergebnis exakt ? */
      if (0!=cmpee(&tmp1, &tmp2) || 0!=cmpee(&tmp1, &(arg->u)))
      {
         /* nein, runden */
         round_rel(UP, &(res->u), &EpsSqrt, &(res->u));
      }
   }

   /* --- RundungsMode zuruecksetzen --- */
   setrndmode(rnd);

   /* --- ArgPruefung wieder an --- */
   arg_check = On;

   /* --- kein Fehler mehr moeglich --- */
   return NoErr;
} /* isqrtee() */

